<template>
  <div diff-side>
    <label v-if="diffRow.type !== 'invalidation'">{{diffRow.columnName}}</label>
    <template v-if="diffRow.type === 'text' || diffRow.type === 'foreign-key'">
      <p>
        <span v-for="(change, i) in getDiff(diffRow.diff, perspective)"
              :key="i"
              diff-piece
              :removed="change.removed"
              :added="change.added">{{change.value}}</span>
      </p>
    </template>
    <template v-else-if="diffRow.type === 'invalidation'">
      <div invalidation-wrap>
        <p invalidation v-if="value !== 'Y'">This key has been decommissioned</p>
      </div>
    </template>
    <template v-else>
      <p>{{value}}</p>
    </template>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch, Prop } from 'vue-property-decorator';

import { DiffRow } from '../../lib/diffData';

type Perspective = 'old' | 'new';

import Diff from 'diff';
@Component({
  components: {
  },
})
export default class extends Vue {
  @Prop()
  private diffRow!: DiffRow;
  @Prop()
  private perspective!: Perspective;

  get value() {
    return this.perspective === 'old' ? this.diffRow.oldVal : this.diffRow.newVal;
  }

  private getDiff(input: Diff.Change[], perspective: Perspective): Diff.Change[] {
    const f = perspective === 'old' ? this.leftSideDiff : this.rightSideDiff;
    return f(input);
  }

  private leftSideDiff(input: Diff.Change[]): Diff.Change[] {
    return input.filter(c => !c.added);
  }

  private rightSideDiff(input: Diff.Change[]): Diff.Change[] {
    return input.filter(c => !c.removed);
  }
}
</script>

<style lang="scss" scoped>
$label-height: 12px;

[diff-side] {

  flex: 1;
  display: flex;
  flex-direction: column;

  label {
    color: rgba(0, 0, 0, 0.54);
    font-size: $label-height;
    line-height: $label-height;
  }

  p {
    margin: 0;
  }

  [diff-piece] {
    &[added] {
      background: rgba(0, 255, 0, 0.25);
    }
    &[removed] {
      background: rgba(255, 0, 0, 0.25);
    }
  }

  [invalidation-wrap] {
    height: 3em;
    [invalidation] {
      height: 3em;
      border: 1px solid #ffa700;
      background: #ffe1b9;
      display: flex;
      align-items: center;
      justify-content: center;
    }
  }
}
</style>
